#!/bin/sh

LOOPMNT=/mnt/live/modules/
#LOOPMNT=/mnt

STACK=/mnt/tmp/stack
#STACK=/mnt/sda3/init/stack

expand()
{
local SAVE=$LANG
export LANG=C

find $LOOPMNT/$1/ | sed -e "s@$LOOPMNT/$1/@@" | sed -e "/^$/d"

export LANG=$SAVE
}

#=== START ===#
PKG=$1

if [ ! -d $STACK ]
then
	mkdir -p $STACK
fi

if [ -f $STACK/$PKG ]
then
	echo "already activate $PKG"
	exit 1
fi

#=== STEP 1 対象ピックアップ ===#
SKIP=""
LEN=0
for i in `expand $PKG`
do
	DEST="/${i%/*}"
	OBJ=${i##*/}

	if [ -n "$SKIP" ]
	then
		if [ "${i:0:$LEN}" = $SKIP ]
		then
		# 新規ディレクトリ内実態 #
			continue
		fi
		SKIP=""
	fi

	if [ -f $DEST/.act.new.$OBJ ]
	then
	# 同一実態へ別ACT重なり #
	# 前のACTの当重なり実態を無効化 #
		rm /$i
		rm $DEST/.act.new.$OBJ
		if [ -e $DEST/.act.org.$OBJ ]
		then
			mv $DEST/.act.org.$OBJ /$i
		fi
	fi 

	if [ -d $LOOPMNT/$PKG/$i ]
	then
	# ディレクトリをシンボリックリンクする #
	#--- directory ---#
		if [ -d /$i ]
		then
		# 元の実態はディレクトリ #
			continue
		fi
		# 新規ディレクトリ処理 #
		echo $i >> $STACK/$PKG
		SKIP=$i
		LEN=${#SKIP}
		continue
	fi
	echo $i >> $STACK/$PKG
done
	
#=== STEP 2 シンボリックリンク設定 ===#
if [ ! -f $STACK/$PKG ]
then
	exit 0
fi
for i in `cat $STACK/$PKG`
do
	DEST="/${i%/*}"
	OBJ=${i##*/}

	if [ -e /$i ]
	then
	# シンボリックリンク対象先に既に実態有り #
		mv /$i $DEST/.act.org.$OBJ
	fi

	# シンボリックリンク設定 #
	touch $DEST/.act.new.$OBJ
	ln -sf $LOOPMNT/$PKG/$i $DEST/.

done
	
exit 0	

